// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import GetAccountInfoRequest from "./../request/account/GetAccountInfoRequest";
import GetAccountBalanceRequest from "./../request/account/GetAccountBalanceRequest";
import ValidatedRequest from "../../../core/validation/ValidatedArgs";
import { GetAccountInfoQuery } from "../../../app/usecase/query/account/info/GetAccountInfoQuery";
import { QueryBus } from "../../../core/query/QueryBus";
import Injectable from "../../../core/injectable/Injectable";
import { HederaId } from "../../../domain/context/shared/HederaId";
import { LogError } from "../../../core/decorator/LogErrorDecorator";
import { GetAccountBalanceQuery } from "../../../app/usecase/query/account/balance/GetAccountBalanceQuery";
class AccountInPort {
    queryBus;
    constructor(queryBus = Injectable.resolve(QueryBus)) {
        this.queryBus = queryBus;
    }
    async getInfo(request) {
        ValidatedRequest.handleValidation("GetAccountInfoRequest", request);
        const res = await this.queryBus.execute(new GetAccountInfoQuery(HederaId.from(request.account.accountId)));
        const account = {
            id: res.account.id.toString(),
            accountEvmAddress: res.account.evmAddress,
            publicKey: res.account.publicKey ? res.account.publicKey : undefined,
            alias: res.account.alias,
        };
        return account;
    }
    async getBalance(request) {
        ValidatedRequest.handleValidation("GetAccountBalanceRequest", request);
        const res = await this.queryBus.execute(new GetAccountBalanceQuery(request.securityId, request.targetId));
        return res.payload;
    }
}
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [GetAccountInfoRequest]),
    __metadata("design:returntype", Promise)
], AccountInPort.prototype, "getInfo", null);
__decorate([
    LogError,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [GetAccountBalanceRequest]),
    __metadata("design:returntype", Promise)
], AccountInPort.prototype, "getBalance", null);
const Account = new AccountInPort();
export default Account;
